xpath_query_impl Struct Reference
Collaboration diagram for xpath_query_impl:
[legend]

## Public Member Functions

| xpath_query_impl ()

## Static Public Member Functions

static xpath_query_impl * | create ()
static void | destroy (void *ptr)

## Public Attributes

xpath_ast_node * | root
xpath_allocator | alloc
xpath_memory_block | block

## Detailed Description

Definition at line 10092 of file pugixml.cpp.

## Constructor & Destructor Documentation

## xpath_query_impl()

xpath_query_impl::xpath_query_impl | ( |  | ) |

inline

Definition at line 10112 of file pugixml.cpp.

: root(0), alloc(&block)
{
block.next = 0;
block.capacity = sizeof(block.data);
}
xpath_memory_block::next
xpath_memory_block * next
Definition: pugixml.cpp:6188
xpath_query_impl::root
xpath_ast_node * root
Definition: pugixml.cpp:10118
xpath_memory_block::data
char data[4096]
Definition: pugixml.cpp:6197
xpath_memory_block::capacity
size_t capacity
Definition: pugixml.cpp:6189
xpath_query_impl::alloc
xpath_allocator alloc
Definition: pugixml.cpp:10119
xpath_query_impl::block
xpath_memory_block block
Definition: pugixml.cpp:10120

## Member Function Documentation

## create()

static xpath_query_impl* xpath_query_impl::create | ( |  | ) |

inline static

Definition at line 10094 of file pugixml.cpp.

References xml_memory_management_function_storage< T >::allocate.

{
void* memory = xml_memory::allocate(sizeof(xpath_query_impl));
return new (memory) xpath_query_impl();
}
xpath_query_impl::xpath_query_impl
xpath_query_impl()
Definition: pugixml.cpp:10112
xml_memory_management_function_storage::allocate
static allocation_function allocate
Definition: pugixml.cpp:163
xpath_query_impl
Definition: pugixml.cpp:10092

## destroy()

static void xpath_query_impl::destroy | ( | void * | ptr | ) |

inline static

Definition at line 10101 of file pugixml.cpp.

References xml_memory_management_function_storage< T >::deallocate.

{
if (!ptr) return;
// free all allocated pages
static_cast<xpath_query_impl*>(ptr)->alloc.release();
// free allocator memory (with the first page)
xml_memory::deallocate(ptr);
}
xpath_allocator::release
void release()
Definition: pugixml.cpp:6331
xml_memory_management_function_storage::deallocate
static deallocation_function deallocate
Definition: pugixml.cpp:164
xpath_query_impl::alloc
xpath_allocator alloc
Definition: pugixml.cpp:10119
xpath_query_impl
Definition: pugixml.cpp:10092

## Member Data Documentation

## alloc

xpath_allocator xpath_query_impl::alloc

Definition at line 10119 of file pugixml.cpp.

## block

xpath_memory_block xpath_query_impl::block

Definition at line 10120 of file pugixml.cpp.

## root

xpath_ast_node* xpath_query_impl::root

Definition at line 10118 of file pugixml.cpp.

Referenced by evaluate_string_impl().

The documentation for this struct was generated from the following file:

- pugixml.cpp